/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.0
 *
 * @date        2023-03-31
 *
 * @attention
 *
 *  Copyright (C) 2023 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (GEEHY SOFTWARE PACKAGE LICENSE).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the GEEHY SOFTWARE PACKAGE LICENSE for the governing permissions
 *  and limitations under the License.
 */

/* Includes */
#include "main.h"

/** @addtogroup Examples
  @{
*/

/** @addtogroup USART_Printf
  @{
*/

/** @defgroup USART_Printf_Macros Macros
  @{
*/

#define DATA_BUF_SIZE       (16)
#define DEBUG_USART         USART1

/**@} end of group USART_Printf_Macros */

/** @defgroup USART_Printf_Variables Variables
  @{
*/

uint8_t rxDataBuf[DATA_BUF_SIZE] = {'h','e','l','l','o',',','w','o','r','l','d','!'};

/**@} end of group USART_Printf_Variables */

/** @defgroup USART_Printf_Functions Functions
  @{
*/

/* USART Init */
void USART_Init(void);
/*!
 * @brief       Main program
 *
 * @param       None
 *
 * @retval      None
 */
int main(void)
{
    APM_MINI_LEDInit(LED2);
    APM_MINI_LEDOff(LED2);

    APM_DelayInit(APM_DELAY_MS);

    USART_Init();

    while (1)
    {
        printf("%s\r\n", rxDataBuf);
        APM_MINI_LEDToggle(LED2);
        APM_Delay(500);
    }
}

/*!
 * @brief       USART Init
 *
 * @param       None
 *
 * @retval      None
 */
void USART_Init(void)
{
    USART_Config_T usartConfig;

    usartConfig.baudRate = 9600;                /*!< BaudRate is 9600 */
    usartConfig.wordLength = USART_WORD_LEN_8B; /*!< Word length is 8bit */
    usartConfig.stopBits = USART_STOP_BIT_1;    /*!< One stop bit */
    usartConfig.parity = USART_PARITY_NONE;     /*!< Parity disable */
    usartConfig.interrupt = USART_INT_NONE;     /*!< No interrupt */
    usartConfig.mode = USART_MODE_TX_RX;        /*!< Enable receive and transmit */
    /*  DEBUG_USART configuration */
    USART_Config(DEBUG_USART, &usartConfig);

    /*  Enable DEBUG_USART */
    USART_Enable(DEBUG_USART);
}

#if defined (__CC_ARM) || defined (__ICCARM__) || (defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050))

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @param       *f:  pointer to a FILE that can recording all information
*              needed to control a stream
*
* @retval      The characters that need to be send.
*/
int fputc(int ch, FILE* f)
{
    /* send a byte of data to the serial port */
    USART_TxData8(DEBUG_USART, (uint8_t)ch);

    /* wait for the data to be send */
    while (USART_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == RESET);

    return (ch);
}

#elif defined (__GNUC__)

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @retval      The characters that need to be send.
*/
int __io_putchar(int ch)
{
    /* send a byte of data to the serial port */
    USART_TxData8(DEBUG_USART, ch);

    /* wait for the data to be send  */
    while (USART_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == RESET);

    return ch;
}

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       file:  Meaningless in this function.
*
* @param       *ptr:  Buffer pointer for data to be sent.
*
* @param       len:  Length of data to be sent.
*
* @retval      The characters that need to be send.
*/
int _write(int file, char *ptr, int len)
{
    int i;
    for (i = 0; i < len; i++)
    {
        __io_putchar(*ptr++);
    }

    return len;
}

#else
  #warning Not supported compiler type
#endif

/**@} end of group USART_Printf_Functions */
/**@} end of group USART_Printf */
/**@} end of group Examples */
